-- Inspired by MinUI by grantus...  Thanks man, your code helped me understand the API better for my first addon.
-- This is just a player portrait replacement as MinUI itself didn't do exactly what I was looking for.
-- EzPlayerPortrait v0.71
-- Todo:  	Currently does NOT recognize rogues and clerics that use Decays or Decays/Convictions.
--			Make the items scale better when changing size.

local size1 = {110, 350}
local size2 = {40, size1[2]}
local ezppinit = false
local mousestate = false
local portraitlockout = false
local resourcelockout = false
local locked = false
local offsetx = 0
local offsety = 0
local offsetx2 = 0
local offsety2 = 100
local barwidth = size1[2] - 10
local barheight = 25
local playerdetails = nil
local playercalling = nil
local playercallinginit = false
local ezppbufflist
local ezppbuffdetails
local convictionid
local context = UI.CreateContext("EzPPContext")

local function svload(addon)
	if addon == "EzPlayerPortrait" then
		if ppoffsetx then
			offsetx = ppoffsetx
		else
			offsetx = 0
		end
		
		if ppoffsety then
			offsety = ppoffsety
		else
			offsety = 0
		end

		if ppoffsetx2 then
			offsetx2 = ppoffsetx2
		else
			offsetx2 = 0
		end		
		
		if ppoffsety2 then
			offsety2 = ppoffsety2
		else
			offsety2 = 100
		end		
		
		if pplocked then
			locked = pplocked
		else
			locked = false
		end
	end
	ezppinit = true
end

local function svsave(addon)
   	ppoffsetx = offsetx
   	ppoffsety = offsety
	ppoffsetx2 = offsetx2
	ppoffsety2 = offsety2
	pplocked = locked
end	

local function ezppenvironment(size1)
	portraitframe = UI.CreateFrame("Frame", "PortraitFrame", context)
	portraitframe:SetHeight(size1[1])
	portraitframe:SetWidth(size1[2])
	portraitframe:SetLayer(1)
	portraitframe:SetPoint("TOPLEFT", context, "TOPLEFT", offsetx, offsety)
	portraitframe:SetBackgroundColor(0,0,0,0.6)
	
	function portraitframe.Event:LeftDown()
		if locked == false and portraitlockout == false then
			resourcelockout = true
			mousestate = true
			local mousepos = Inspect.Mouse()
			mousedownposx = mousepos.x - portraitframe:GetLeft()
			mousedownposy = mousepos.y - portraitframe:GetTop()
		end
	end
	
	function portraitframe.Event:MouseMove()
		if locked == false and portraitlockout == false then
			if mousestate == true then
				local mousepos = Inspect.Mouse()
				offsetx = mousepos.x - mousedownposx
				offsety = mousepos.y - mousedownposy
				portraitframe:SetPoint("TOPLEFT", context, "TOPLEFT", offsetx, offsety)
			end
		end
	end
	
	function portraitframe.Event:LeftUp()
		if locked == false and portraitlockout == false then
			if mousestate == true then
				mousestate = false
				resourcelockout = false
				ppoffsetx = offsetx
				ppoffsety = offsety
			end
		end
	end
	
	portraitborder = UI.CreateFrame("Texture", "PortraitBorder", portraitframe)
	portraitborder:SetTexture("EzPlayerPortrait", "textures/EzPPBorder.png")
	portraitborder:SetHeight(size1[1])
	portraitborder:SetWidth(size1[2])
	portraitborder:SetLayer(0)
	portraitborder:SetPoint("TOPLEFT", portraitframe, "TOPLEFT", 0,0)
	
	playerleveltext = UI.CreateFrame("Text", "PlayerLevelText", portraitframe)
	playerleveltext:SetPoint("TOPLEFT", portraitframe, "TOPLEFT", 3,4)
	playerleveltext:SetFontColor(1,1,0,1)
	playerleveltext:SetFontSize(10)
	playerleveltext:SetLayer(2)
	playerleveltext:SetText("Level:")
	playerleveltext:ResizeToText()
	
	playerlevel = UI.CreateFrame("Text", "PlayerLevel", playerleveltext)
	playerlevel:SetPoint("TOPCENTER", playerleveltext, "BOTTOMCENTER", 0,-7)
	playerlevel:SetLayer(2)
	playerlevel:SetFontColor(1,0,0,1)
	playerlevel:SetFontSize(15)
	
	playername = UI.CreateFrame("Text", "PlayerName", portraitframe)
	playername:SetPoint("TOPLEFT", portraitframe, "TOPLEFT", 32,2)
	playername:SetLayer(2)
	playername:SetFontColor(0,1,0,1)
	playername:SetFontSize(20)
	
	playerrole = UI.CreateFrame("Texture", "PlayerRole", playername)
	playerrole:SetPoint("TOPLEFT", playername, "TOPRIGHT", 5,5)
	playerrole:SetWidth(20)
	playerrole:SetHeight(20)
	playerrole:SetLayer(2)
	
	playerchargestexture = UI.CreateFrame("Texture", "PlayerChargesTexture", playername)
	playerchargestexture:SetPoint("TOPLEFT", playername, "TOPRIGHT", 30,3)
	playerchargestexture:SetTexture("EzPlayerPortrait", "textures/planar.png")
	playerchargestexture:SetWidth(15)
	playerchargestexture:SetHeight(30)
	playerchargestexture:SetLayer(2)
	
	playerplanar = UI.CreateFrame("Text", "PlayerPlanar", playerchargestexture)
	playerplanar:SetPoint("TOPCENTER", playerchargestexture, "TOPCENTER", 1,4)
	playerplanar:SetLayer(3)
	playerplanar:SetFontColor(0.9,0.9,0.9,1)
	playerplanar:SetFontSize(17)
	
	playervitalitytexture = UI.CreateFrame("Texture", "PlayerVitalityTexture", playerchargestexture)
	playervitalitytexture:SetPoint("TOPLEFT", playerchargestexture, "TOPRIGHT", 10,0)
	playervitalitytexture:SetTexture("EzPlayerPortrait", "textures/vitality.png")
	playervitalitytexture:SetWidth(30)
	playervitalitytexture:SetHeight(30)
	playervitalitytexture:SetLayer(2)
	
	playervitality = UI.CreateFrame("Text", "PlayerVitality", playervitalitytexture)
	playervitality:SetPoint("TOPCENTER", playervitalitytexture, "TOPCENTER", 0,5)
	playervitality:SetLayer(3)
	playervitality:SetFontColor(0.9,0.9,0.9,0.5)
	playervitality:SetFontSize(15)
	
	playerpvp = UI.CreateFrame("Text", "PlayerPVP", portraitframe)
	playerpvp:SetPoint("TOPRIGHT", portraitframe, "TOPRIGHT", -60,12)
	playerpvp:SetLayer(2)
	playerpvp:SetFontSize(17)
	playerpvp:SetFontColor(1,0,0,0.3)
	playerpvp:SetText("PVP")
	playerpvp:ResizeToText()	
	
	playercombat = UI.CreateFrame("Texture", "PlayerCombat", portraitframe)
	playercombat:SetPoint("TOPRIGHT", portraitframe, "TOPRIGHT", -20,5)
	playercombat:SetTexture("EzPlayerPortrait", "textures/combat.png")
	playercombat:SetAlpha(0.3)
	playercombat:SetWidth(40)
	playercombat:SetHeight(40)
	playercombat:SetLayer(2)
		
	lock = UI.CreateFrame("Texture", "Lock", portraitframe)
	lock:SetPoint("TOPRIGHT", portraitframe, "TOPRIGHT", 0,0)
	lock:SetLayer(2)
	lock:SetHeight(15)
	lock:SetWidth(15)
	if locked == false then
		lock:SetTexture("EzPlayerPortrait", "textures/lock_off.png")
	else
		lock:SetTexture("EzPlayerPortrait", "textures/lock_on.png")
	end
		
	function lock.Event:LeftClick()
		if locked == false then
			lock:SetTexture("EzPlayerPortrait", "textures/lock_on.png")
			locked = true
		else
			lock:SetTexture("EzPlayerPortrait", "textures/lock_off.png")
			locked = false
		end
	end
	
	playerhealthbar = UI.CreateFrame("Frame", "PlayerHealthBar", portraitframe)
	playerhealthbar:SetPoint("BOTTOMLEFT", portraitframe, "BOTTOMLEFT", 5,-35)
	playerhealthbar:SetLayer(3)
	playerhealthbar:SetBackgroundColor(0,0.3,0,0.5)
	playerhealthbar:SetHeight(barheight)
	playerhealthbar:SetWidth(barwidth)
	
	playerhealthbarfill = UI.CreateFrame("Frame", "PlayerHealthBarFill", playerhealthbar)
	playerhealthbarfill:SetPoint("BOTTOMLEFT", playerhealthbar, "BOTTOMLEFT", 0,0)
	playerhealthbarfill:SetLayer(4)
	playerhealthbarfill:SetBackgroundColor(0,0.5,0,1)
	playerhealthbarfill:SetHeight(barheight)
	playerhealthbarfill:SetWidth(barwidth)

	playerhealthshadow = UI.CreateFrame("Text", "PlayerHealthShadow", playerhealthbar)
	playerhealthshadow:SetPoint("BOTTOMLEFT", playerhealthbar, "BOTTOMLEFT", 6,1)
	playerhealthshadow:SetLayer(5)
	playerhealthshadow:SetFontColor(0,0,0,1.0)
	playerhealthshadow:SetFontSize(20)
	
	playerhealth = UI.CreateFrame("Text", "PlayerHealth", playerhealthbar)
	playerhealth:SetPoint("BOTTOMLEFT", playerhealthbar, "BOTTOMLEFT", 5,1)
	playerhealth:SetLayer(6)
	playerhealth:SetFontColor(1,1,1,1)
	playerhealth:SetFontSize(20)
	
	playerhealthpercentshadow = UI.CreateFrame("Text", "PlayerHealthPercentShadow", playerhealthbar)
	playerhealthpercentshadow:SetPoint("BOTTOMRIGHT", playerhealthbar, "BOTTOMRIGHT", -4,1)
	playerhealthpercentshadow:SetLayer(5)
	playerhealthpercentshadow:SetFontColor(0,0,0,1)
	playerhealthpercentshadow:SetFontSize(20)
		
	playerhealthpercent = UI.CreateFrame("Text", "PlayerHealthPercent", playerhealthbar)
	playerhealthpercent:SetPoint("BOTTOMRIGHT", playerhealthbar, "BOTTOMRIGHT", -5,1)
	playerhealthpercent:SetLayer(6)
	playerhealthpercent:SetFontColor(1,1,1,1)
	playerhealthpercent:SetFontSize(20)
	
	playerhealthbarborder = UI.CreateFrame("Texture", "PortraitBorder", portraitframe)
	playerhealthbarborder:SetLayer(6)
	playerhealthbarborder:SetTexture("EzPlayerPortrait", "textures/EzPPBarBorder.png")
	playerhealthbarborder:SetPoint("BOTTOMLEFT", portraitframe, "BOTTOMLEFT", 5,-35)
	playerhealthbarborder:SetHeight(barheight)
	playerhealthbarborder:SetWidth(barwidth)	

	playermanabar = UI.CreateFrame("Frame", "PlayerManaBar", portraitframe)
	playermanabar:SetPoint("BOTTOMLEFT", portraitframe, "BOTTOMLEFT", 5,-5)
	playermanabar:SetLayer(3)
	playermanabar:SetBackgroundColor(0.1,0.1,0.1,0.5)
	playermanabar:SetHeight(barheight)
	playermanabar:SetWidth(barwidth)
	
	playermanabarfill = UI.CreateFrame("Frame", "PlayerManaBarFill", playermanabar)
	playermanabarfill:SetPoint("BOTTOMLEFT", playermanabar, "BOTTOMLEFT", 0,0)	
	playermanabarfill:SetLayer(4)
	playermanabarfill:SetBackgroundColor(0.1,0.1,0.1,1)
	playermanabarfill:SetHeight(barheight)
	playermanabarfill:SetWidth(barwidth)

	playermanashadow = UI.CreateFrame("Text", "PlayerManaShadow", playermanabar)
	playermanashadow:SetPoint("BOTTOMLEFT", playermanabar, "BOTTOMLEFT", 6,1)
	playermanashadow:SetLayer(5)
	playermanashadow:SetFontColor(0,0,0,1)
	playermanashadow:SetFontSize(20)

	playermana = UI.CreateFrame("Text", "PlayerMana", playermanabar)
	playermana:SetPoint("BOTTOMLEFT", playermanabar, "BOTTOMLEFT", 5,1)
	playermana:SetLayer(6)
	playermana:SetFontColor(1,1,1,1)
	playermana:SetFontSize(20)
	
	playermanapercentshadow = UI.CreateFrame("Text", "PlayerManaPercentShadow", playermanabar)
	playermanapercentshadow:SetPoint("BOTTOMRIGHT", playermanabar, "BOTTOMRIGHT", -4,1)
	playermanapercentshadow:SetLayer(5)
	playermanapercentshadow:SetFontColor(0,0,0,1)
	playermanapercentshadow:SetFontSize(20)
		
	playermanapercent = UI.CreateFrame("Text", "PlayerManaPercent", playermanabar)
	playermanapercent:SetPoint("BOTTOMRIGHT", playermanabar, "BOTTOMRIGHT", -5,1)
	playermanapercent:SetLayer(6)
	playermanapercent:SetFontColor(1,1,1,1)
	playermanapercent:SetFontSize(20)
	
	playermanabarborder = UI.CreateFrame("Texture", "PortraitBorder", portraitframe)
	playermanabarborder:SetLayer(6)
	playermanabarborder:SetTexture("EzPlayerPortrait", "textures/EzPPBarBorder.png")
	playermanabarborder:SetPoint("BOTTOMLEFT", portraitframe, "BOTTOMLEFT", 5,-5)
	playermanabarborder:SetHeight(barheight)
	playermanabarborder:SetWidth(barwidth)
	
	print("EzPlayerPortrait v0.71 laoded...")
end

local function convictiontick()
	ezppbufflist = Inspect.Buff.List("player")
	if not ezppbufflist then return end 
	ezppbuffdetails = Inspect.Buff.Detail("player", ezppbufflist)

	for k, v in pairs(ezppbuffdetails) do
		if v.name == "Conviction" then
			convictionid = k
			resourcetext:SetText(tostring(math.floor(v.remaining)))
			resourcetext:ResizeToText()
			
			resourceicon1:SetTexture("Rift", v.icon)
			resourceicon2:SetTexture("Rift", v.icon)
			resourceicon3:SetTexture("Rift", v.icon)
			resourceicon4:SetTexture("Rift", v.icon)
			
			if v.stack == 4 then
				resourceicon1:SetVisible(true)
				resourceicon2:SetVisible(true)
				resourceicon3:SetVisible(true)
				resourceicon4:SetVisible(true)
			elseif v.stack == 3 then
				resourceicon1:SetVisible(true)
				resourceicon2:SetVisible(true)
				resourceicon3:SetVisible(true)
				resourceicon4:SetVisible(false)
			elseif v.stack == 2 then
				resourceicon1:SetVisible(true)
				resourceicon2:SetVisible(true)
				resourceicon3:SetVisible(false)
				resourceicon4:SetVisible(false)
			else 
				resourceicon1:SetVisible(true)
				resourceicon2:SetVisible(false)
				resourceicon3:SetVisible(false)
				resourceicon4:SetVisible(false)
			end
		end
	end

end

local function buffclear(unit, buffs)
	for k,v in pairs(buffs) do
		if k == convictionid then
			resourcetext:SetText("")
			resourcetext:ResizeToText()		
			resourceicon1:SetVisible(false)
			resourceicon2:SetVisible(false)
			resourceicon3:SetVisible(false)
			resourceicon4:SetVisible(false)
		end
	end
end

local function chargetick()
	local chargelevel = Inspect.Unit.Detail("player").charge
	if chargelevel ~= nil then
		playercharge:SetText(tostring(chargelevel) .. " / " .. "100")
		playercharge:ResizeToText()
		playerchargeshadow:SetText(tostring(chargelevel) .. " / " .. "100")
		playerchargeshadow:ResizeToText()
		playerchargebarfill:SetWidth(barwidth*(chargelevel/100))
	end
end

local function warcombotick()
	local warcombolevel = Inspect.Unit.Detail("player").combo
	if warcombolevel ~= nil then
		if warcombolevel == 3	then
			resourceicon1:SetVisible(true)
			resourceicon2:SetVisible(true)
			resourceicon3:SetVisible(true)
		elseif warcombolevel == 2	then
			resourceicon1:SetVisible(true)
			resourceicon2:SetVisible(true)
			resourceicon3:SetVisible(false)
		elseif warcombolevel == 1 then
			resourceicon1:SetVisible(true)
			resourceicon2:SetVisible(false)
			resourceicon3:SetVisible(false)
		elseif warcombolevel == 0 then
			resourceicon1:SetVisible(false)
			resourceicon2:SetVisible(false)
			resourceicon3:SetVisible(false)			
		end
	end
end



local function playerresource()
	if playercallinginit == false then
		resourceframe = UI.CreateFrame("Frame", "ResourceFrame", context)
		resourceframe:SetAlpha(0.1)
		resourceframe:SetHeight(size2[1])
		resourceframe:SetWidth(size2[2])
		resourceframe:SetLayer(1)
		resourceframe:SetPoint("TOPLEFT", context, "TOPLEFT", offsetx2, offsety2)
		resourceframe:SetBackgroundColor(0,0,0,0.6)	
		
		resourceborder = UI.CreateFrame("Texture", "ResourceBorder", resourceframe)
		resourceborder:SetTexture("EzPlayerPortrait", "textures/EzPPResourceBorder.png")
		resourceborder:SetHeight(size2[1])
		resourceborder:SetWidth(size2[2])
		resourceborder:SetLayer(0)
		resourceborder:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 0,0)
	end
	
	function resourceframe.Event:LeftDown()
		if locked == false and resourcelockout == false then
			mousestate = true
			portraitlockout = true
			local mousepos = Inspect.Mouse()
			mousedownposx = mousepos.x - resourceframe:GetLeft()
			mousedownposy = mousepos.y - resourceframe:GetTop()
		end
	end
	
	function resourceframe.Event:MouseMove()
		if locked == false and resourcelockout == false then 
			if mousestate == true then
				local mousepos = Inspect.Mouse()
				offsetx2 = mousepos.x - mousedownposx
				offsety2 = mousepos.y - mousedownposy
				resourceframe:SetPoint("TOPLEFT", context, "TOPLEFT", offsetx2, offsety2)
			end
		end
	end
	
	function resourceframe.Event:LeftUp()
		if locked == false and resourcelockout == false then
			if mousestate == true then
				mousestate = false
				portraitlockout = false
				ppoffsetx2 = offsetx2
				ppoffsety2 = offsety2
			end
		end
	end		
	
	if playercalling == "cleric" and playercallinginit == false then
		resourceframe:SetHeight(size2[1])
		resourceframe:SetWidth(182)
		resourceborder:SetHeight(size2[1])
		resourceborder:SetWidth(182)
						
		resourcetext = UI.CreateFrame("Text", "ResourceText", resourceframe)
		resourcetext:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 5,5)
		resourcetext:SetFontSize(20)
			
		resourceicon1 = UI.CreateFrame("Texture", "ResourceIcon1", resourceframe)
		resourceicon1:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 40,5)
		resourceicon1:SetVisible(false)			
		resourceicon1:SetLayer(1)
		resourceicon1:SetHeight(29)
		resourceicon1:SetWidth(29)
			
		resourceborder1 = UI.CreateFrame("Texture", "ResourceBorder1", resourceframe)
		resourceborder1:SetTexture("EzPlayerPortrait", "textures/EzPPIconBorder.png")
		resourceborder1:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 40,5)
		resourceborder1:SetLayer(2)
		resourceborder1:SetHeight(31)
		resourceborder1:SetWidth(31)	

		resourceicon2 = UI.CreateFrame("Texture", "ResourceIcon2", resourceframe)
		resourceicon2:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 75,5)
		resourceicon2:SetVisible(false)			
		resourceicon2:SetLayer(1)
		resourceicon2:SetHeight(29)
		resourceicon2:SetWidth(29)
			
		resourceborder2 = UI.CreateFrame("Texture", "ResourceBorder2", resourceframe)
		resourceborder2:SetTexture("EzPlayerPortrait", "textures/EzPPIconBorder.png")
		resourceborder2:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 75,5)
		resourceborder2:SetLayer(2)
		resourceborder2:SetHeight(31)
		resourceborder2:SetWidth(31)			

		resourceicon3 = UI.CreateFrame("Texture", "ResourceIcon3", resourceframe)
		resourceicon3:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 110,5)
		resourceicon3:SetVisible(false)
		resourceicon3:SetLayer(1)
		resourceicon3:SetHeight(29)
		resourceicon3:SetWidth(29)
			
		resourceborder3 = UI.CreateFrame("Texture", "ResourceBorder3", resourceframe)
		resourceborder3:SetTexture("EzPlayerPortrait", "textures/EzPPIconBorder.png")
		resourceborder3:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 110,5)
		resourceborder3:SetLayer(2)
		resourceborder3:SetHeight(31)
		resourceborder3:SetWidth(31)	
			
		resourceicon4 = UI.CreateFrame("Texture", "ResourceIcon3", resourceframe)
		resourceicon4:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 145,5)
		resourceicon4:SetVisible(false)
		resourceicon4:SetLayer(1)
		resourceicon4:SetHeight(29)
		resourceicon4:SetWidth(29)
			
		resourceborder4 = UI.CreateFrame("Texture", "ResourceBorder4", resourceframe)
		resourceborder4:SetTexture("EzPlayerPortrait", "textures/EzPPIconBorder.png")
		resourceborder4:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 145,5)
		resourceborder4:SetLayer(2)
		resourceborder4:SetHeight(31)
		resourceborder4:SetWidth(31)				
		
		table.insert(Event.System.Update.Begin, {convictiontick, "EzPlayerPortrait", "Conviction_Refresh"})
		table.insert(Event.Buff.Remove, {buffclear, "EzPlayerPortrait", "Conviction_Clear"})
	
	elseif playercalling == "mage" and playercallinginit == false then
		resourceframe:SetHeight(barheight)
		resourceframe:SetWidth(barwidth)
		resourceborder:SetHeight(barheight+3)
		resourceborder:SetWidth(barwidth+3)
		resourceborder:SetLayer(7)
		
		playerchargebar = UI.CreateFrame("Frame", "PlayerChargeBar", resourceframe)
		playerchargebar:SetPoint("BOTTOMLEFT", resourceframe, "BOTTOMLEFT", 1,1)
		playerchargebar:SetLayer(3)
		playerchargebar:SetBackgroundColor(0,0.3,0.3,0.5)
		playerchargebar:SetHeight(barheight)
		playerchargebar:SetWidth(barwidth)
	
		playerchargebarfill = UI.CreateFrame("Frame", "PlayerChargeFill", playerchargebar)
		playerchargebarfill:SetPoint("BOTTOMLEFT", playerchargebar, "BOTTOMLEFT", 0,0)	
		playerchargebarfill:SetLayer(4)
		playerchargebarfill:SetBackgroundColor(0,.5,.5,1)
		playerchargebarfill:SetHeight(barheight)
		playerchargebarfill:SetWidth(0)

		playerchargeshadow = UI.CreateFrame("Text", "PlayerChargeShadow", playerchargebar)
		playerchargeshadow:SetPoint("BOTTOMLEFT", playerchargebar, "BOTTOMLEFT", 6,1)
		playerchargeshadow:SetLayer(5)
		playerchargeshadow:SetFontColor(0,0,0,1)
		playerchargeshadow:SetFontSize(20)

		playercharge = UI.CreateFrame("Text", "PlayerMana", playerchargebar)
		playercharge:SetPoint("BOTTOMLEFT", playerchargebar, "BOTTOMLEFT", 5,1)
		playercharge:SetLayer(6)
		playercharge:SetFontColor(1,1,1,1)
		playercharge:SetFontSize(20)
		
		table.insert(Event.System.Update.Begin, {chargetick, "EzPlayerPortrait", "Charge_Refresh"})
	
	elseif playercalling == "warrior" and playercallinginit == false then
		resourceframe:SetHeight(size2[1])
		resourceframe:SetWidth(125)
		resourceborder:SetHeight(size2[1])
		resourceborder:SetWidth(125)
						
		resourceicon1 = UI.CreateFrame("Texture", "ResourceIcon1", resourceframe)
		resourceicon1:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 5,4)
		resourceicon1:SetTexture("EzPlayerPortrait", "textures/warcombo.png")
		resourceicon1:SetVisible(false)			
		resourceicon1:SetLayer(1)
		resourceicon1:SetHeight(31)
		resourceicon1:SetWidth(44)
			
		resourceicon2 = UI.CreateFrame("Texture", "ResourceIcon2", resourceframe)
		resourceicon2:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 40,4)
		resourceicon2:SetTexture("EzPlayerPortrait", "textures/warcombo.png")
		resourceicon2:SetVisible(false)			
		resourceicon2:SetLayer(1)
		resourceicon2:SetHeight(31)
		resourceicon2:SetWidth(44)
			
		resourceicon3 = UI.CreateFrame("Texture", "ResourceIcon3", resourceframe)
		resourceicon3:SetPoint("TOPLEFT", resourceframe, "TOPLEFT", 75,4)
		resourceicon3:SetTexture("EzPlayerPortrait", "textures/warcombo.png")		
		resourceicon3:SetVisible(false)
		resourceicon3:SetLayer(1)
		resourceicon3:SetHeight(31)
		resourceicon3:SetWidth(44)
		
		table.insert(Event.System.Update.Begin, {warcombotick, "EzPlayerPortrait", "War_Combo_Refresh"})
	elseif playercalling == "rogue" and playercallinginit == false then	
		resourceframe:SetAlpha(0)
	end
	
	playercallinginit = true
end

local function manaupdate()
	local manatick = Inspect.Unit.Detail("player").mana
	local manamax = Inspect.Unit.Detail("player").manaMax
	if manatick and manamax ~= nil then
		playermana:SetText(manatick .. " / " .. tostring(manamax))
		playermana:ResizeToText()
		playermanashadow:SetText(manatick .. " / " .. tostring(manamax))
		playermanashadow:ResizeToText()
		manapercent = string.format("%s%%", (math.ceil(manatick/manamax * 100)))
		playermanapercent:SetText(tostring(manapercent))
		playermanapercent:ResizeToText()
		playermanapercentshadow:SetText(tostring(manapercent))
		playermanapercentshadow:ResizeToText()
		playermanabarfill:SetWidth(barwidth*(manatick/manamax))
	end
end

local function powerupdate()
	local powertick = Inspect.Unit.Detail("player").power
	if powertick ~= nil then
		playermana:SetText(powertick .. " / " .. "100")
		playermana:ResizeToText()
		playermanashadow:SetText(powertick .. " / " .. "100")
		playermanashadow:ResizeToText()
		playermanabarfill:SetWidth(barwidth*(powertick/100))
	end
end

local function energyupdate()
	local energytick = Inspect.Unit.Detail("player").energy
	if energytick ~= nil then
		playermana:SetText(energytick .. " / " .. "100")
		playermana:ResizeToText()
		playermanashadow:SetText(energytick .. " / " .. "100")
		playermanashadow:ResizeToText()
		playermanabarfill:SetWidth(barwidth*(energytick/100))
	end
end


local function getplayerdetails()
	while playerdetails == nil do
		playerdetails = Inspect.Unit.Detail("player")
	end
		
	if playerdetails ~= nil then
		playername:SetText(playerdetails.name)
		playername:ResizeToText()
	
		if playerdetails.role == "heal" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/healer.png")
		elseif playerdetails.role == "dps" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/dps.png")
		elseif playerdetails.role == "tank" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/tank.png")
		elseif playerdetails.role == "support" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/support.png")
		end

		playerlevel:SetText(tostring(playerdetails.level))
		playerlevel:ResizeToText()
		playerplanar:SetText(tostring(playerdetails.planar))
		playerplanar:ResizeToText()		
		playervitality:SetText(tostring(playerdetails.vitality) .. "%")
		playervitality:ResizeToText()	
	
		if playerdetails.pvp == true then
			playerpvp:SetAlpha(1)
		else
			playerpvp:SetAlpha(0.3)
		end		

		playerhealthshadow:SetText(tostring(playerdetails.health) .. " / " .. tostring(playerdetails.healthMax))
		playerhealthshadow:ResizeToText()
		playerhealth:SetText(tostring(playerdetails.health) .. " / " .. tostring(playerdetails.healthMax))
		playerhealth:ResizeToText()
		healthpercent = string.format("%s%%", (math.ceil(playerdetails.health/playerdetails.healthMax * 100)))		
		playerhealthpercentshadow:SetText(tostring(healthpercent))
		playerhealthpercentshadow:ResizeToText()
		playerhealthpercent:SetText(tostring(healthpercent))
		playerhealthpercent:ResizeToText()			
		playercalling = playerdetails.calling

		if playercalling == "cleric" then
			playermanabar:SetBackgroundColor(0,0,0.3,0.5)
			playermanabarfill:SetBackgroundColor(0,0,0.5,1)
			resource = tostring(playerdetails.mana) .. " / " .. tostring(playerdetails.manaMax)
			resourcepercent = string.format("%s%%", (math.ceil(playerdetails.mana/playerdetails.manaMax * 100)))
			playermanashadow:SetText(resource)
			playermanashadow:ResizeToText()	
			playermana:SetText(resource)
			playermana:ResizeToText()		
			playermanapercentshadow:SetText(tostring(resourcepercent))
			playermanapercentshadow:ResizeToText()
			playermanapercent:SetText(tostring(resourcepercent))
			playermanapercent:ResizeToText()
			table.insert(Event.Unit.Detail.Mana, {manaupdate, "EzPlayerPortrait", "Update_Mana"})
			table.insert(Event.Unit.Detail.ManaMax, {manaupdate, "EzPlayerPortrait", "Update_Max_Mana"})			
		elseif playercalling == "mage" then
			playermanabar:SetBackgroundColor(0,0,0.3,0.5)
			playermanabarfill:SetBackgroundColor(0,0,0.5,1)
			resource = tostring(playerdetails.mana) .. " / " .. tostring(playerdetails.manaMax)
			resourcepercent = string.format("%s%%", (math.ceil(playerdetails.mana/playerdetails.manaMax * 100)))
			playermanashadow:SetText(resource)
			playermanashadow:ResizeToText()	
			playermana:SetText(resource)
			playermana:ResizeToText()		
			playermanapercentshadow:SetText(tostring(resourcepercent))
			playermanapercentshadow:ResizeToText()
			playermanapercent:SetText(tostring(resourcepercent))
			playermanapercent:ResizeToText()
			table.insert(Event.Unit.Detail.Mana, {manaupdate, "EzPlayerPortrait", "Update_Mana"})
			table.insert(Event.Unit.Detail.ManaMax, {manaupdate, "EzPlayerPortrait", "Update_Max_Mana"})
		elseif playercalling == "warrior" then
			playermanabar:SetBackgroundColor(0.3,0.3,0,0.5)
			playermanabarfill:SetBackgroundColor(0.5,0.5,0,1)
			resource = tostring(playerdetails.power) .. " / " .. "100"
			playermanashadow:SetText(resource)
			playermanashadow:ResizeToText()	
			playermana:SetText(resource)
			playermana:ResizeToText()		
			table.insert(Event.Unit.Detail.Power, {powerupdate, "EzPlayerPortrait", "Update_Power"})
		elseif playercalling == "rogue" then
			playermanabar:SetBackgroundColor(0.3,0,0.3,0.5)
			playermanabarfill:SetBackgroundColor(0.5,0,0.5,1)
			resource = tostring(playerdetails.energy) .. " / " .. "100"
			playermanashadow:SetText(resource)
			playermanashadow:ResizeToText()	
			playermana:SetText(resource)
			playermana:ResizeToText()
			table.insert(Event.Unit.Detail.Energy, {energyupdate, "EzPlayerPortrait", "Update_Energy"})
		end
		
		playerresource()
	end
	
	playerdetails = nil
end

local function healthupdate()
	local healthtick = Inspect.Unit.Detail("player").health
	local healthmax = Inspect.Unit.Detail("player").healthMax
	if healthtick and healthmax ~= nil then
		playerhealth:SetText(healthtick .. " / " .. tostring(healthmax))
		playerhealth:ResizeToText()
		playerhealthshadow:SetText(healthtick .. " / " .. tostring(healthmax))
		playerhealthshadow:ResizeToText()
		healthpercent = string.format("%s%%", (math.ceil(healthtick/healthmax * 100)))
		playerhealthpercent:SetText(tostring(healthpercent))
		playerhealthpercent:ResizeToText()
		playerhealthpercentshadow:SetText(tostring(healthpercent))	
		playerhealthpercentshadow:ResizeToText()
		playerhealthbarfill:SetWidth(barwidth*(healthtick/healthmax))
	end
end

local function planarupdate()
	local planartick = Inspect.Unit.Detail("player").planar
	if planartick ~= nil then
		playerplanar:SetText(tostring(planartick))
		playerplanar:ResizeToText()
	end
end
	
local function vitalityupdate()
	local vitalitytick = Inspect.Unit.Detail("player").vitality
	if vitalitytick ~= nil then
		playervitality:SetText(tostring(vitalitytick) .. "%")
		playervitality:ResizeToText()
	end
end

local function roleupdate()
	local role = Inspect.Unit.Detail("player").role
	if role ~= nil then
		if role == "heal" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/healer.png")
		elseif role == "dps" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/dps.png")
		elseif role == "tank" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/tank.png")
		elseif role == "support" then
			playerrole:SetTexture("EzPlayerPortrait", "textures/support.png")
		end
	end
end
	
local function pvpupdate()
	pvpflag = Inspect.Unit.Detail("player")
	if pvpflag ~= nil then
		if pvpflag.pvp == true then
			playerpvp:SetAlpha(1)
		else
			playerpvp:SetAlpha(0.3)
		end
	end
end	
	
local function combatflagon()
	playercombat:SetAlpha(1)
	if playercalling ~= "rogue" then
		resourceframe:SetAlpha(1)
	else
		resourceframe:SetAlpha(0)
	end
end
	
local function combatflagoff()
	playercombat:SetAlpha(0.3)
	if playercalling ~= "rogue" then
		resourceframe:SetAlpha(0.1)
	else
		resourceframe:SetAlpha(0)
	end
end

local function unitavailable()
	if ezppinit == true then
		ezppenvironment(size1)
		table.insert(Event.Unit.Available, {getplayerdetails, "EzPlayerPortrait", "Get_Player_Details"})
	end
end

table.insert(Event.Unit.Detail.Health, {healthupdate, "EzPlayerPortrait", "Update_Health"})
table.insert(Event.Unit.Detail.HealthMax, {healthupdate, "EzPlayerPortrait", "Update_Max_Health"})
table.insert(Event.Unit.Detail.Planar, {planarupdate, "EzPlayerPortrait", "Update_Planar"})
table.insert(Event.Unit.Detail.Vitality, {vitalityupdate, "EzPlayerPortrait", "Update_Vitality"})
table.insert(Event.Unit.Detail.Role, {roleupdate, "EzPlayerPortrait", "Update_Role"})
table.insert(Event.Unit.Detail.Pvp, {pvpupdate, "EzPlayerPortrait", "Update_PVP"})
table.insert(Event.System.Secure.Enter, {combatflagon, "EzPlayerPortrait", "Update_Combat_FlagON"})
table.insert(Event.System.Secure.Leave, {combatflagoff, "EzPlayerPortrait", "Update_Combat_FlagOFF"})
table.insert(Event.Addon.Load.End, {unitavailable, "EzPlayerPortrait", "Addon_Loaded"})
table.insert(Event.Addon.SavedVariables.Save.Begin, {svsave, "EzPlayerPortrait", "Save_Saved_variables"})
table.insert(Event.Addon.SavedVariables.Load.End, {svload, "EzPlayerPortrait", "Load_Saved_Variables"})


